SYS4   ;	sys4/asm
 	ORG	5000H
 @ERROR	LD	A,(IY+12)	;get error code
 	AND	3FH		;mask high 2 bits off
 	LD	B,A		;save it here for test
 	LD	C,0		;counter initial
 	LD	HL,TABLE2	;command lookup table
 	CP	50		;48 errors here
 	JR	C,DOERROR	;valid if <45
 	LD	HL,UNDEFINE	;undefined error code
 	CALL	4030H		;display it
 ERRDONE	LD	A,8
 	CALL	401BH
 	LD	A,'.'
 	CALL	401BH
 	LD	A,13
 	CALL	401BH		;video out
 	BIT	6,(IY+12)	;prompt?
 	CALL	NZ,PROMPT	;get it
 	BIT	7,(IY+12)	;return?
 	JP	Z,402DH		;back to menu
 	BIT	5,(IY+16)
 	RES	5,(IY+16)	;return to overlay?
 	RET	Z		;go back straight
 	LD	A,(IY+44)	;return vector
 	RST	28H		;go to it
 PROMPT	LD	HL,PMTMSG	;prompt message
 	JP	4039H		;wait for enter
 DOERROR	PUSH	AF
 	LD	A,10
 	CALL	401BH
 	LD	A,1EH
 	CALL	401BH
 	POP	AF
 FINDERR	BIT	7,(HL)		;high bit on ?
 	INC	HL		;bump pointer
 	JR	Z,FINDERR	;continue
 	LD	A,B		;get error request
 	CP	C		;correct one ?
 	JR	Z,SHOERR	;yes, display it
 	INC	C		;bump counter
 	JR	FINDERR		;continue through table
 SHOERR	DEC	HL		;point to start of line
 	RES	7,(HL)		;high bit off
 ERRLOOP	LD	A,(HL)		;get a table byte
 	BIT	7,A		;terminator ?
 	JR	NZ,ERRDONE	;finished
 	CALL	SHOW1		;show the word
 	INC	HL		;bump pointer
 	JR	ERRLOOP		;continue with sentence
 SHOW1	LD	B,A		;get the word number
 	LD	C,1		;counter
 	PUSH	HL		;save pointer
 	LD	HL,TABLE1	;word table
 FINDSHO	BIT	7,(HL)		;high bit on/word start?
 	INC	HL		;bump pointer
 	JR	Z,FINDSHO	;continue if not
 	LD	A,C		;get count
 	CP	B		;one we want ?
 	JR	Z,PUTERR	;display the word
 	INC	C
 	JR	FINDSHO		;else continue
 PUTERR	DEC	HL		;word start
 	LD	A,(HL)		;get first byte
 	AND	7FH		;remove high bit
 	JR	PUTLOOP+1	;print it
 PUTLOOP	LD	A,(HL)		;get a byte
 	BIT	7,A		;end of word
 	JR	NZ,WORDEND
 	CALL	401BH		;display the byte
 	INC	HL		;bump pointer
 	JR	PUTLOOP		;continue
 WORDEND	LD	A,20H		;display a space
 	CALL	401BH
 	POP	HL		;restore table pointer
 	RET			;done
 PMTMSG	DB	1DH,1EH,'Key <ENTER> to continue.',3
 UNDEFINE	DB	'Undefined Error Code ',3
 TABLE1	DB	'N'+80H,'O'
 	DB	'E'+80H,'rror'
 	DB	'P'+80H,'arity'
 	DB	'O'+80H,'n'
 	DB	'H'+80H,'eader'
 	DB	'R'+80H,'ead'
 	DB	'S'+80H,'eek'
 	DB	'L'+80H,'ost'
 	DB	'D'+80H,'ata'
 	DB	'R'+80H,'ecord'
 	DB	'N'+80H,'ot'
 	DB	'F'+80H,'ound'
 	DB	'A'+80H,'ttempted'
 	DB	'T'+80H,'o'
 	DB	'S'+80H,'ystem'
 	DB	'D'+80H,'evice'
 	DB	'A'+80H,'vailable'
 	DB	'W'+80H,'rite'
 	DB	'F'+80H,'ault'
 	DB	'D'+80H,'isk'
 	DB	'D'+80H,'rive'
 	DB	'D'+80H,'iskette'
 	DB	'P'+80H,'rotected'
 	DB	'I'+80H,'llegal'
 	DB	'L'+80H,'ogical'
 	DB	'F'+80H,'ile'
 	DB	'N'+80H,'umber'
 	DB	'D'+80H,'irectory'
 	DB	'N'+80H,'ame'
 	DB	'G'+80H,'AT'
 	DB	'H'+80H,'IT'
 	DB	'I'+80H,'n'
 	DB	'A'+80H,'ccess'
 	DB	'D'+80H,'enied'
 	DB	'S'+80H,'pace'
 	DB	'F'+80H,'ull'
 	DB	'E'+80H,'OF'
 	DB	'E'+80H,'ncountered'
 	DB	'N'+80H,'ext'
 	DB	'R'+80H,'ecord'
 	DB	'O'+80H,'ut'
 	DB	'O'+80H,'f'
 	DB	'R'+80H,'ange'
 	DB	'P'+80H,'rogram'
 	DB	'F'+80H,'or'
 	DB	'N'+80H,'ew'
 	DB	'L'+80H,'oad'
 	DB	'F'+80H,'ormat'
 	DB	'M'+80H,'emory'
 	DB	'A'+80H,'ttempted'
 	DB	'R'+80H,'OM'
 	DB	'C'+80H,'annot'
 	DB	'H'+80H,'as'
 	DB	'B'+80H,'een'
 	DB	'O'+80H,'pened'
 	DB	'R'+80H,'eady'
 	DB	'D'+80H,'AM'
 	DB	'L'+80H,'ocate'
 	DB	'O'+80H,'utside'
 	DB	'B'+80H,'oundry'
 	DB	'D'+80H,'oor'
 	DB	'O'+80H,'pen'
 	DB	'T'+80H,'ime'
 	DB	'B'+80H,'y'
 	DB	'K'+80H,'im Watt'
 	DB	'C'+80H,'ommand'
 	DB	'P'+80H,'arameter'
 	DB	'U'+80H,'nknown'
 	DB	'C'+80H,'ode'
 	DB	'U'+80H,'ndefined'
 	DB	'F'+80H,'eature'
 	DB	80H
 TABLE2	DB	1+80H,2		;0
 	DB	3+80H,2,4,5,6	;1
 	DB	7+80H,2,4,6	;2
 	DB	8+80H,9,4,6	;3
 	DB	3+80H,2,4,6	;4
 	DB	9+80H,10,11,12,4,6	;5
 	DB	13+80H,14,6,15,9,10	;6
 	DB	13+80H,14,6,15,9,10	;7
 	DB	63+80H,41,4,20,21	;8
 	DB	3+80H,2,4,5,18	;9
 	DB	7+80H,2,4,18	;10
 	DB	8+80H,9,4,18	;11
 	DB	3+80H,2,4,18	;12
 	DB	9+80H,10,11,12,4,18	;13
 	DB	18+80H,19,4,20,21	;14
 	DB	22+80H,18,23	;15
 	DB	24+80H,25,26,27	;16
 	DB	28+80H,6,2	;17
 	DB	28+80H,18,2	;18
 	DB	24+80H,26,29	;19
 	DB	30+80H,6,2	;20
 	DB	30+80H,18,2	;21
 	DB	31+80H,6,2	;22
 	DB	31+80H,18,2	;23
 	DB	26+80H,11,32,28	;24
 	DB	26+80H,33,34	;25
 	DB	28+80H,35,36	;26
 	DB	20+80H,35,36	;27
 	DB	37+80H,38	;28
 	DB	39+80H,40,41,42,43	;29
 	DB	36+80H,28	;30
 	DB	44+80H,11,12	;31
 	DB	24+80H,21,27	;32
 	DB	1+80H,35,45,46,16	;33
 	DB	47+80H,26,48,2	;34
 	DB	49+80H,19	;35
 	DB	50+80H,14,47,51,49	;36
 	DB	52+80H,33,23,26	;37
 	DB	26+80H,53,11,54,55	;38
 	DB	15+80H,26,11,17	;39
 	DB	21+80H,11,32,15	;40
 	DB	15+80H,40,11,12	;41
 	DB	13+80H,14,6,59,20,60	;42
 	DB	1+80H,22,32,21	;43
 	DB	61+80H,62,4,21	;44
 	DB	44+80H,64,65	;45
 	DB	50+80H,14,18,59,20,60	;46
 	DB	24+80H,66,67		;47
 	DB	68+80H,2,69		;48
 	DB	70+80H,71		;49
 	DB	80H
 	END	5000H
